
/*
 * $Id: Client.cc,v 1.1.1.2 1999/01/27 08:40:44 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include <strstream.h>

#include "Connection.h"
#include "CltXact.h"
#include "Client.h"
#include "StatPhaseMgr.h"
#include "SharedOpts.h"
#include "CltOpts.h"
#include "World.h"

#include "gadgets.h"
#include "globals.h"

void Client::configure(CltConnMgr *aConnMgr) {
	theConnMgr = aConnMgr;
	theXacts.limit(2);
}

void Client::start() {
	TheStatPhaseMgr->unlock();
	maintainCcLevel();
}

void Client::noteXactDone(CltXact *x) {
	Assert(x);
	theConnMgr->put(x->conn());
	theXacts.put(x);
	maintainCcLevel();
}

void Client::maintainCcLevel() {
	theConnMgr->order(this);
}

void Client::noteConnReady(Connection *conn) {
	CltXact *x = theXacts.get();
	x->exec(this, conn);
}
