
/*
 * $Id: Xaction.cc,v 1.1.1.2 1999/01/27 08:40:44 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "Connection.h"
#include "Clock.h"
#include "StatPing.h"
#include "StatPhaseMgr.h"
#include "SharedOpts.h"
#include "Xaction.h"
#include "globals.h"

void Xaction::reset() {
	theConn = 0;
	theId.clear();
	theStartTime = theLifeTime = Time();
	theState = stNone;
}

void Xaction::start(Connection *aConn) {
	Assert(aConn);
	theConn = aConn;

	theStartTime = TheClock;
	CallStat(ThePinger, xactBeg());
}

void Xaction::stop(int errNo) {
	Assert(theConn);
	if (theState == stSpaceWaiting)
		theConn->theWr.stop(this);
	else
		theConn->theRd.stop(this);
	
	theLifeTime = TheClock - theStartTime;

	if (!errNo) {
		TheXactComplCnt++;
		CallStat(ThePinger, xactEnd());
		CallStat(TheSoOftenPinger, xactLifeTime(theLifeTime));
	} else {
		theConn->bad(true);
		CallStat(ThePinger, err(errNo));
	}

	theState = stDone;
}
