
/*
 * $Id: ListenQueue.h,v 1.1.1.1 1999/01/27 08:40:45 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef LISTEN_QUEUE_H
#define LISTEN_QUEUE_H

class SelectUser;

// collects stats on accept(2) calls and optimises
// number of accept calls per select(2) cycle
class ListenQueue {
	public:
		ListenQueue();

		void listener(SelectUser *aListener, int aListFD) { theListener = aListener; theListFD = aListFD; }

		// listener closed an old connection
		void noteClose() {}
		// listener accepted new connections
		void accepted(int count) { theAccCount += count; }

		// start, middle, end of select cycle
		void begCycle(int readyCount);
		void tick(int fd);
		void endCycle();

	protected:
		SelectUser *theListener; // support only one for now
		int theListFD;

		double theAccAvg;    // accepted per ready fd
		int theReadyCount;   // ready fd this cycle
		int theAccCount;     // accepted this cycle
		
};

#endif
