
/*
 * $Id: gadgets.cc,v 1.1.1.1 1999/01/27 08:40:45 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "xstd.h"

// #include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>

#include <iostream.h>

#include "Assert.h"
#include "gadgets.h"

char *StrDup(const char *str, int len) {

	if (!str) return 0;

	char *copy = new char [len+1];
	memcpy(copy, str, len);
	copy[len] = '\0';

	return copy;
}

bool isInt(const char *s, int &i) {
	if (s) {
		char *ptr = 0;
		const int h = (int) strtol(s, &ptr, 10);
		if (ptr != s) {
			i = h;
			return true;
		}
	}
	return false;
}

int xatoi(const char *s, int def) { 
	isInt(s, def);
	return def;
}

void configureStream(ostream &os, int prec) {
	os.precision(prec);
	os.setf(ios::fixed, ios::floatfield);
	os.setf(ios::showpoint, ios::basefield);
}

int GetMaxFD() {
	struct rlimit rl;
	if (getrlimit(RLIMIT_NOFILE, &rl) < 0)
		return -1;
	return (int)rl.rlim_max;
}

int SetMaxFD(int maxFD) {
	struct rlimit rl;
	rl.rlim_max = Min(maxFD, GetMaxFD());
	rl.rlim_cur = rl.rlim_max;
	if (rl.rlim_cur > 0)
		Assert(setrlimit(RLIMIT_NOFILE, &rl) >= 0);
	return rl.rlim_cur;
}
