
/*
 * $Id: NetAddr.h,v 1.1.1.1 1999/01/27 08:40:45 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef X_NET_ADDR_H
#define X_NET_ADDR_H

#include <string.h>
#include "String.h"

class NetAddr {
	public:
		NetAddr(): thePort(-1) {}
		NetAddr(const char *aHost, int aPort): thePort(-1) { host(aHost); port(aPort); }
		NetAddr(const NetAddr &addr): thePort(-1) { *this = addr; }

		NetAddr &operator = (const NetAddr &addr) { host(addr.host()); port(addr.port()); return *this; }

		bool operator == (const NetAddr &addr) const { return thePort == addr.thePort && strcasecmp(theHost, addr.theHost) == 0; }
		bool operator != (const NetAddr &addr) const { return thePort != addr.thePort || strcasecmp(theHost, addr.theHost) != 0; }

		const String &host() const { return theHost; }
		int port() const { return thePort; }

		void host(const String &aHost);
		void port(int aPort) { thePort = aPort; }

		ostream &print(ostream &os) const;

	protected:
		String theHost;
		int thePort;
};

inline ostream &operator <<(ostream &os, const NetAddr &addr) { return addr.print(os); }

#endif
