
/*
 * $Id: String.h,v 1.1.1.1 1999/01/27 08:40:45 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef X_STRING_CLASS_H
#define X_STRING_CLASS_H

// a simple string class; to be improved later if needed
class String {
	public:
		String(const char *s = 0): theBuf(0) { set(s); }
		String(const String &s): theBuf(0) { set(s); }
		~String() { set(0); }

		String &operator =(const String &s) { set(s); return *this; }
		String &operator =(const char *s) { set(s); return *this; }

		char *buf() { return theBuf; }
		const char *str() const { return theBuf; }
		operator const char *() const { return str(); }

		char operator [](int idx) const { return theBuf[idx]; }
		char &operator [](int idx) { return theBuf[idx]; }

		void reset(int newLen);

	protected:
		void set(const char *s);

	public:
		char *theBuf;
};

#endif
